﻿// Note this implementation is rather limited, only used for ease of access to data.
using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;

namespace UnboundColumnUpdatingHierarchy.Models
{
    [DataContract()]
    public partial class HierarchicalEmployeeDTO : EmployeeDTO
    {
        [DataMember()]
        public List<PersonDTO> Person { get; set; }

        public HierarchicalEmployeeDTO()
        {
            this.Person = new List<PersonDTO>();
        }
    }

    /// <summary>
    /// Assembler for <see cref="EmployeeDTO"/>.
    /// </summary>
    public static partial class HierarchicalEmployeeAssembler
    {
        /// <summary>
        /// Invoked when <see cref="ToDTO"/> operation is about to return.
        /// </summary>
        /// <param name="dto"><see cref="EmployeeDTO"/> converted from <see cref="Employee"/>.</param>
        static partial void OnDTO(this Employee entity, HierarchicalEmployeeDTO dto);

       
        /// <summary>
        /// Converts this instance of <see cref="Employee"/> to an instance of <see cref="EmployeeDTO"/>.
        /// </summary>
        /// <param name="entity"><see cref="Employee"/> to convert.</param>
        public static HierarchicalEmployeeDTO ToHrcDTO(this Employee entity)
        {
            if (entity == null) return null;

            HierarchicalEmployeeDTO dto = null;

            dto = new HierarchicalEmployeeDTO();

            dto.BusinessEntityID = entity.BusinessEntityID;
            dto.NationalIDNumber = entity.NationalIDNumber;
            dto.LoginID = entity.LoginID;
            dto.OrganizationLevel = entity.OrganizationLevel;
            dto.JobTitle = entity.JobTitle;
            dto.BirthDate = entity.BirthDate;
            dto.MaritalStatus = entity.MaritalStatus;
            dto.Gender = entity.Gender;
            dto.HireDate = entity.HireDate;
            dto.SalariedFlag = entity.SalariedFlag;
            dto.VacationHours = entity.VacationHours;
            dto.SickLeaveHours = entity.SickLeaveHours;
            dto.CurrentFlag = entity.CurrentFlag;
            dto.rowguid = entity.rowguid;
            dto.ModifiedDate = entity.ModifiedDate;
            dto.Person_BusinessEntityID = entity.Person.BusinessEntityID;
            dto.Person.Add(entity.Person.ToDTO());

            entity.OnDTO(dto);

            return dto;
        }
    }
}
